var Day = /* @__PURE__ */ ((Day2) => {
  Day2[Day2["Sunday"] = 0] = "Sunday";
  Day2[Day2["Monday"] = 1] = "Monday";
  Day2[Day2["Tuesday"] = 2] = "Tuesday";
  Day2[Day2["Wednesday"] = 3] = "Wednesday";
  Day2[Day2["Thursday"] = 4] = "Thursday";
  Day2[Day2["Friday"] = 5] = "Friday";
  Day2[Day2["Saturday"] = 6] = "Saturday";
  return Day2;
})(Day || {});
class CronGenerator {
  constructor() {
    this.expression = "* * * * *";
  }
  spliceIntoPosition(position, value) {
    const segments = this.expression.split(" ");
    segments[position] = value;
    return this.cron(segments.join(" "));
  }
  get() {
    return this.expression;
  }
  cron(expression) {
    this.expression = expression;
    return this;
  }
  everyMinute() {
    return this.spliceIntoPosition(0, "*");
  }
  everyTwoMinutes() {
    return this.spliceIntoPosition(0, "*/2");
  }
  everyFiveMinutes() {
    return this.spliceIntoPosition(0, "*/5");
  }
  everyTenMinutes() {
    return this.spliceIntoPosition(0, "*/10");
  }
  everyFifteenMinutes() {
    return this.spliceIntoPosition(0, "*/15");
  }
  everyThirtyMinutes() {
    return this.spliceIntoPosition(0, "0,30");
  }
  everyXMinutes(minutes) {
    return this.spliceIntoPosition(0, `*/${minutes}`);
  }
  everyHour() {
    return this.spliceIntoPosition(0, "0");
  }
  everyTwoHours() {
    return this.spliceIntoPosition(1, "*/2").spliceIntoPosition(0, "0");
  }
  everyThreeHours() {
    return this.spliceIntoPosition(1, "*/3").spliceIntoPosition(0, "0");
  }
  everySixHours() {
    return this.spliceIntoPosition(1, "*/6").spliceIntoPosition(0, "0");
  }
  everyTwelveHours() {
    return this.spliceIntoPosition(1, "*/12").spliceIntoPosition(0, "0");
  }
  everyXHours(hours) {
    return this.spliceIntoPosition(1, `*/${hours}`).spliceIntoPosition(0, "0");
  }
  daily() {
    return this.spliceIntoPosition(1, "0").spliceIntoPosition(0, "0");
  }
  days(days) {
    const elements = Array.isArray(days) ? days : [days];
    return this.spliceIntoPosition(4, elements.join(","));
  }
  weekdays() {
    return this.days(`${1 /* Monday */}-${5 /* Friday */}`);
  }
  weekends() {
    return this.days(`${6 /* Saturday */},${0 /* Sunday */}`);
  }
  mondays() {
    return this.days(1 /* Monday */);
  }
  tuesdays() {
    return this.days(2 /* Tuesday */);
  }
  wednesdays() {
    return this.days(3 /* Wednesday */);
  }
  thursdays() {
    return this.days(4 /* Thursday */);
  }
  fridays() {
    return this.days(5 /* Friday */);
  }
  saturdays() {
    return this.days(6 /* Saturday */);
  }
  sundays() {
    return this.days(0 /* Sunday */);
  }
  weekly() {
    return this.spliceIntoPosition(0, "0").spliceIntoPosition(1, "0").spliceIntoPosition(4, "0");
  }
  at(time) {
    return this.dailyAt(time);
  }
  dailyAt(time) {
    const segments = time.split(":");
    const hour = (+segments[0]).toString();
    const minute = (+segments[1]).toString() || "0";
    return this.spliceIntoPosition(1, hour).spliceIntoPosition(0, minute);
  }
  weeklyOn(day, time) {
    return this.dailyAt(time).days(day);
  }
  monthly() {
    return this.spliceIntoPosition(0, "0").spliceIntoPosition(1, "0").spliceIntoPosition(2, "1");
  }
  monthlyOn(day, time) {
    return this.dailyAt(time).spliceIntoPosition(2, day.toString());
  }
  quarterly() {
    return this.spliceIntoPosition(0, "0").spliceIntoPosition(1, "0").spliceIntoPosition(2, "1").spliceIntoPosition(3, "1-12/3");
  }
  yearly() {
    return this.spliceIntoPosition(0, "0").spliceIntoPosition(1, "0").spliceIntoPosition(2, "1").spliceIntoPosition(3, "1");
  }
  yearlyOn(month = 1, dayOfMonth = 1, time = "00:00") {
    return this.dailyAt(time).spliceIntoPosition(2, dayOfMonth.toString()).spliceIntoPosition(3, month.toString());
  }
}

function cron() {
  return new CronGenerator();
}

export { Day, cron };
